/*********************************************************************

 Author        : ADI - Apps            www.analog.com/MicroConverter

 Date          : Dec. 2006

 File          : PSM.c

 Hardware      : Applicable to ADuC703x 

 Description   : The PSM produces a HV interrupt when the supply goes below 6V
		
*********************************************************************/
#include<aduc7033.h>

void delay(int);
void My_IRQ_Function(void);				//	IRQ Funtion Prototype 

int main(void){
char HVstatus;
	do{					
		HVDAT = 0x08; 					// Enable PSM 
		HVCON = 0x08; 					// Write to Config0
		do{
			HVstatus = HVCON;
		}
		while(HVstatus & 0x1); 			// Wait until command is finished
	}
	while (!(HVstatus & 0x4));			// Transmit command is correct

	IRQ = My_IRQ_Function;				// Specify Interrupt Service Rountine 
	GP2DAT = 0x02000000;				// Enable P2.1 (GPIO8) as an output
	IRQEN = 0x10000;					// Enable HV interrupt
while (1){
	delay(200000);
	}				
}
/********************************************************************/
/*                                                                  */
/*		Interrupt Service Rountine									*/
/*                                                                  */
/********************************************************************/

void My_IRQ_Function(){
char HVstatus, a;
	if ((IRQSTA & 0x10000) != 0)
	{
		do
		{					
			do
			{					
				HVCON = 0x02; 					// Read HVSTA
				do
				{
					HVstatus = HVCON;
				}
				while(HVstatus & 0x1); 			// Wait until command is finished
			}
			while (!(HVstatus & 0x2));			// Read command is correct
			a = HVDAT; 							
			GP2DAT ^=0x020000;					// Complement P2.1
		}
		while (a&0x20);						// Check that the level is back to normal
	} 				
	return ;
}

void delay (int length) {
   	while (length >=0)
    	length--;
}


